/* Some commonly used macros
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef COMMON_H
#define COMMON_H

/** \file common.h
 * \brief common macros
 */

/** \brief align to 32 bit */
#define aligned4 __attribute__((aligned(4)))
/** \brief align to 256 bit */
#define aligned32 __attribute__((aligned(32)))

/** \brief minimum of \a a and \a b
 * \param a a
 * \param b b
 * \return minimum of \a a and \a b */
#define min(a, b) ((a) < (b) ? (a) : (b))

inline static void prefetch(const void * ptr) {
	asm volatile("pld %a0" :: [ptr] "p" (ptr) : "cc");
}

#endif

