/* CFI Flash driver
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#ifndef FLASH_H
#define FLASH_H

#include <inttypes.h>
#include "driver.h"

/** \addtogroup flash
 * @{
 */

/** \file flash.h
 * \brief flash interface
 */

extern struct Driver flashDriver;

bool flashBlockQueryLock(uint32_t block);

void flashBlockLock(uint32_t block);

void flashBlockUnlock(uint32_t block);

void flashBlockLockdown(uint32_t block);

bool flashBlockErase(uint32_t block);

bool flashBlockWriteShort(uint32_t addr, uint16_t data);

bool flashBlockWriteBuffered(uint32_t addr, const uint16_t * data,
	uint16_t length);

/** @} */

#endif

