/* LED driver
   Copyright (c) 2010 Networked Systems Group, University of Kaiserslautern

This file is part of the Imote2 Bootloader

The Bootloader is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

The Bootloader is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/

#include "led.h"

/** \file led.c
 * \brief LED driver
 */

static void init(struct Driver * driver);

/** \brief Led driver structure */
struct Driver ledDriver = {
	.name = "LED",
	
	.init = init
};

/** \brief initialize leds */
static void init(struct Driver * driver) {
	/* set function and pin directions */
	GPIO_SET_ALT_FUNC(LED_RED, 0, GPIO_OUT);
	GPIO_SET_ALT_FUNC(LED_GREEN, 0, GPIO_OUT);
	GPIO_SET_ALT_FUNC(LED_BLUE, 0, GPIO_OUT);
	
	/* clear all leds */
	ledOff(LED_RED);
	ledOff(LED_GREEN);
	ledOff(LED_BLUE);
}

/* ledOn and ledOff are declared inline in led.h */

